#Seguidor de surcos y arboles, ROBEDU , Desarrollado por Rocio Godoy, Emanuel Laporta, Valentina Troche
#Ir a /usr/share/sugar/activities/TurtleBots.activity/plugins/butia/pybot/
#Iniciar el servidor: python pybot_server.py DEBUG
#En otra pestana correr el cliente: python pybot_client.py

#Librerias
import sys
sys.path.insert(0, '/usr/share/sugar/activities/TurtleBots.activity/plugins/butia')
from pybot import pybot_client
import time
from datetime import datetime


#Inicializacion de variables
robot = pybot_client.robot()
vecesGiro = 1
lastTree = 0 #0: Nada, 1: arbol derecho, 2: arbol izquierdo.
flag = start = 0
elapsed = datetime(2015, 12, 29, 23, 59, 0) - datetime(2015, 12, 29, 23, 59, 0)


#<--INICIO_PROGRAMA

while flag == 0:

  #SENSO SURCOS
  dist_SurcoDer = robot.getDistance(5)
  dist_SurcoIzq = robot.getDistance(6)
  print ("\nSensores Surco:\n")
  print dist_SurcoDer
  print dist_SurcoIzq

  #AVANZAR
  if dist_SurcoDer > 30000 and dist_SurcoIzq > 30000:
    robot.set2MotorSpeed(1, 350, 1, 350)
    time.sleep(0.2)

    vecesGiro = 1
    lastTree = start = 0
    elapsed = datetime(2015, 12, 29, 23, 59, 0) - datetime(2015, 12, 29, 23, 59, 0)

  #DOBLAR A LA DERECHA
  elif dist_SurcoDer > 30000:
    robot.set2MotorSpeed(0, 350, 1, 350)

    time.sleep(vecesGiro * 0.1)
    robot.set2MotorSpeed(0, 0, 0, 0)
    vecesGiro += 1

  #DOBLAR A LA IZQUIERDA
  elif dist_SurcoIzq > 30000:
    robot.set2MotorSpeed(1, 400, 0, 400)

    time.sleep(vecesGiro * 0.1)
    robot.set2MotorSpeed(0, 0, 0, 0)
    vecesGiro += 1


  #ANDANDO FUERA DEL SURCO
  elif dist_SurcoDer < 30000 and dist_SurcoIzq < 30000:
    vecesGiro = 1

    if lastTree == 0:
      elapsed = datetime(2015, 12, 29, 23, 59, 0) - datetime(2015, 12, 29, 23, 59, 0)
      start = datetime.now() #Seteo tiempo inicial

    robot.set2MotorSpeed(1, 350, 1, 350)
    time.sleep(0.2)

    #SENSO ARBOLES
    dist_ArbolDer = robot.getDistance(4)
    dist_ArbolIzq = robot.getDistance(1)
    print ("\nSensores Arbol:\n")
    print dist_ArbolDer
    print dist_ArbolIzq


    #ENCONTRE ARBOL DERECHO
    if dist_ArbolDer < 48000:
      print("Encontre arbol a mi derecha")

      #CORRIJO RUTA
      if dist_ArbolDer < 34000:
        print("\nArbol muy cerca a mi derecha, doblo.\n")        
        robot.set2MotorSpeed(1, 400, 0, 400)
        time.sleep(0.3)
        robot.set2MotorSpeed(1, 300, 1, 300)
        time.sleep(0.2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        robot.set2MotorSpeed(0, 300, 1, 300)

      time.sleep(0.2)
      lastTree = 1 #Asigno arbol a la derecha
      start = datetime.now() #Seteo tiempo inicial


    #ENCONTRE ARBOL IZQUIERDO
    elif dist_ArbolIzq < 48000:
      print("Encontre arbol a mi izquierda")

      #CORRIJO RUTA
      if dist_ArbolIzq < 34000:
        print("\nArbol muy cerca a mi izquierda, doblo.\n")
        robot.set2MotorSpeed(0, 400, 1, 400)
        time.sleep(0.3)
        robot.set2MotorSpeed(1, 300, 1, 300)
        time.sleep(0.2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        robot.set2MotorSpeed(1, 300, 0, 290)

      time.sleep(0.2)
      lastTree = 2 #Asigno arbol a la izquierda
      start = datetime.now() #Seteo tiempo inicial



    #SI NO ENCUENTRO SURCO NI ARBOL
    else:
      while dist_SurcoDer < 30000 and dist_SurcoIzq < 30000 and dist_ArbolDer > 48000 and dist_ArbolIzq > 48000 and int(elapsed.seconds) <= 1:
        time.sleep(0.2)
        dist_ArbolDer = robot.getDistance(4)
        dist_ArbolIzq = robot.getDistance(1)
        dist_SurcoDer = robot.getDistance(5)
        dist_SurcoIzq = robot.getDistance(6)
        elapsed = ( datetime.now() - start) #Calculo de tiempo transcurrido
        print("\nTiempo pasado: ")
        print elapsed.seconds


    #VERIFICO SI HAY RUTA
    if int(elapsed.seconds) >= 2:
      print("\nQueme el tiempo\n")

      #SI NO HAY ARBOLES NI SURCO, TERMINO.
      if lastTree == 0:
        flag = 1

      #SI HAY ARBOL A MI DERECHA
      elif lastTree == 1:
        time.sleep(0.2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        print("\nCambio de sendero a la derecha -->\n")
        lastTree = 0 #Asigno arbol 0
        
        robot.set2MotorSpeed(0, 300, 1, 300)
        time.sleep(2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        robot.set2MotorSpeed(1, 400, 1, 400)
        dist_ArbolDer = robot.getDistance(4)
        
        while dist_ArbolDer > 48000: #AVANZO HASTA DETECTAR LA HILERA DE ARBOLES
          print dist_ArbolDer
          time.sleep(0.2)
          dist_ArbolDer = robot.getDistance(4)
        
        time.sleep(2.5)
        robot.set2MotorSpeed(0, 300, 1, 300)
        time.sleep(2)

      #SI HAY ARBOL A MI IZQUIERDA
      elif lastTree == 2:
        time.sleep(0.2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        print("\nCambio de sendero a la izquierda <--\n")
        lastTree = 0 #Asigno arbol 0

        robot.set2MotorSpeed(1, 300, 0, 300)
        time.sleep(2)
        robot.set2MotorSpeed(0, 0, 0, 0)
        robot.set2MotorSpeed(1, 400, 1, 400)
        dist_ArbolIzq = robot.getDistance(1)

        while dist_ArbolIzq > 48000: #AVANZO HASTA DETECTAR LA HILERA DE ARBOLES
          print dist_ArbolIzq
          time.sleep(0.2)
          dist_ArbolIzq = robot.getDistance(1)

        time.sleep(2.5)
        robot.set2MotorSpeed(1, 300, 0, 300)
        time.sleep(2)


  #ERROR?
  else:
    print("\nUps, algo salio mal.\n")
    flag = 1

#-->FIN_PROGRAMA

#DETENER
robot.set2MotorSpeed(0, 0, 0, 0)
print("\n--Fin--\n")
